/* HostsSwitcherV2 --------------------------------------------------
 * CommandLineProcessor.java
 * -------------------------------------
 * CF
 *     2005/10/02	VK쐬
 * -----------------------------------------------------------------*/
package info.createwanwan.hostsswitcher;

import java.io.IOException;

import info.createwanwan.hostsswitcher.common.HostsFileHandler;
import info.createwanwan.hostsswitcher.common.PropertiesHandler;

public class CommandLineProcessor implements Processor{
	private String validatedHostsGroupName = "";
	private PropertiesHandler propHandler;
	private HostsFileHandler hostsHandler;
	private String hostsFilePath;
	
	public CommandLineProcessor(String name) {
		super();
		validatedHostsGroupName = name;
	}

	public void process(String propPath) {
		try {
			propHandler = new PropertiesHandler(propPath);
			hostsFilePath = propHandler.getHostsPath();
			hostsHandler = new HostsFileHandler(hostsFilePath);
			hostsHandler.edit(validatedHostsGroupName);
			hostsHandler.writeNewHosts();
		} catch (HostsSwitcherException e) {
			System.err.println(e.getMessage());
		} catch (Exception e) {
			//System.err.println(e.getMessage());
			e.printStackTrace();
		}
	}

}
