package info.createwanwan.hostsswitcher;

import info.createwanwan.hostsswitcher.common.HostsFileHandler;
import info.createwanwan.hostsswitcher.common.PropertiesHandler;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class HostsSwitcherGuiPanel extends JFrame {
	
	private HostsFileHandler hostsFileHandler;
	private List comboBoxItemsList;
	private JPanel jContentPane = null;
	private JComboBox hostsGroupsComboBox = null;
	private JLabel descriptionLabel = null;
	private JButton editButton = null;
	private JButton closeButton = null;

	/**
	 * This method initializes hostsGroupsComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getHostsGroupsComboBox() {
		if (hostsGroupsComboBox == null) {
			hostsGroupsComboBox = new JComboBox(comboBoxItemsList.toArray());
			hostsGroupsComboBox.setBounds(new java.awt.Rectangle(35,60,200,25));
			hostsGroupsComboBox.setVisible(true);
		}
		return hostsGroupsComboBox;
	}

	/**
	 * This method initializes Edit	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getEditButton() {
		if (editButton == null) {
			editButton = new JButton();
			editButton.setLocation(new java.awt.Point(21,134));
			editButton.setText("Edit");
			editButton.setSize(new java.awt.Dimension(90,25));
			editButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String group = (String)hostsGroupsComboBox.getSelectedItem();
					try {
						hostsFileHandler.edit(group);
						hostsFileHandler.writeNewHosts();
						JOptionPane.showMessageDialog(null, "Success", "Success", JOptionPane.INFORMATION_MESSAGE);
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						JOptionPane.showMessageDialog(null, "Fail to write new hosts file. [" + e1.getMessage() + "]", "Error", JOptionPane.OK_OPTION);
					}
					//System.out.println("actionPerformed() " + group); // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return editButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCloseButton() {
		if (closeButton == null) {
			closeButton = new JButton();
			closeButton.setLocation(new java.awt.Point(181,134));
			closeButton.setText("Close");
			closeButton.setSize(new java.awt.Dimension(90,25));
			closeButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
					System.exit(0);
					//System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return closeButton;
	}

	/**
	 * @param args
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
	}
	 */
	
	/**
	 * This is the default constructor
	 */
	public HostsSwitcherGuiPanel(HostsFileHandler _hostsFileHandler) {
		super();
		this.hostsFileHandler = _hostsFileHandler;
		comboBoxItemsList = hostsFileHandler.getMenuLines();
		if (comboBoxItemsList.size() <= 0) {
			try {
				new PropertiesHandler().resetHostsPath();
				JOptionPane.showMessageDialog(null, "No valid groups are found.", "Error", JOptionPane.OK_OPTION);
			} catch (Exception e) {
				JOptionPane.showMessageDialog(null, "Properties File Error [" + e.getMessage() + "]", "Error", JOptionPane.OK_OPTION);
			} finally {
				System.exit(39);
			}
		}
		comboBoxItemsList.add("<Invalidate All Groups>");
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.setTitle("HostsSwitcher");
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		this.setLocation
			((d.width - this.getSize().width)/2, (d.height - this.getSize().height)/2);
		
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			descriptionLabel = new JLabel();
			descriptionLabel.setBounds(new java.awt.Rectangle(7,20,278,20));
			descriptionLabel.setText("Please choose the group name for a change.");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getHostsGroupsComboBox(), null);
			jContentPane.add(descriptionLabel, null);
			jContentPane.add(getEditButton(), null);
			jContentPane.add(getCloseButton(), null);
		}
		return jContentPane;
	}

}
