/* HostsSwitcherV2 --------------------------------------------------
 * HostsSwitcherMain.java
 * -------------------------------------
 * CF
 *     2005/10/02	VK쐬
 * -----------------------------------------------------------------*/
package info.createwanwan.hostsswitcher;

import java.awt.GraphicsEnvironment;
import java.io.RandomAccessFile;

public class HostsSwitcherMain {
	private static boolean isGuiMode = true;
	private static String validatedHostsGroupName = ""; // nogui [ĥ݂Ŏgp
	private static String propPath 
		= new StringBuffer().append(System.getProperty("user.home"))
		.append(System.getProperty("file.separator"))
		.append("hostsswitcher.properties").toString();

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Check the Arguments
		checkTheArguments(args);
		if (isGuiMode){
			if (!GraphicsEnvironment.isHeadless()) {
				Processor guiProcessor = new GuiProcessor();
				guiProcessor.process(propPath);
			} else {
			// NOT Graphics Environment
				System.out.println("Please run GUI mode in Graphics Environment");
			}
		} else {
			//GraphicsEnvironment.isHeadless();
			Processor cmdLinePcocessor 
				= new CommandLineProcessor(validatedHostsGroupName);
			cmdLinePcocessor.process(propPath);
		}
	}

	private static void checkTheArguments(String[] args){
		for (int i = 0; i < args.length; i++) {
			if (args[i].equals("-nogui")) {
				isGuiMode = false;
				if ((args[i+1] != null) && (!args[i+1].equals(""))){
					validatedHostsGroupName = args[i+1];
				} else {
					printUsageMessage();
				}
			}
			else if (args[i].equals("-prop")) {
				if ((args[i+1] != null) && (!args[i+1].equals(""))){
					propPath = args[i+1];
				} else {
					printUsageMessage();
				}
			}
			else if (args[i].equals("-help")) {
				printUsageMessage();
			}
		}
	}
	
	private static void printUsageMessage(){
		System.out.println
			("usage: java -jar hostsswitcher.jar [-nogui \"؂ւΏۖ\"] [-prop \"ݒvpeB[pX\"]\n" +
			 "   -nogui : R}hC[hŋN. ɐ؂ւΏۖw(K{).\n" +
			 "   -prop  : Cӂ̃vpeB[t@Cǂݍ(w肵Ȃꍇ́A<[U[z[fBNg>/hostsswitcher.properties)");
		System.exit(0);
	}
}
