/* HostsSwitcherV2 --------------------------------------------------
 * HostsFileHandler.java
 * -------------------------------------
 * CF
 *     2005/10/02	VK쐬
 * -----------------------------------------------------------------*/
package info.createwanwan.hostsswitcher.common;

import info.createwanwan.hostsswitcher.HostsSwitcherException;
import info.createwanwan.hostsswitcher.common.LineAnalyzer;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class HostsFileHandler {
	private List dataLines = new ArrayList();
	private List menuLines = new ArrayList();
	private String hostsPath;
	
	public HostsFileHandler(String _hostsPath) throws Exception{
		this.hostsPath = _hostsPath;
		File hosts = new File(hostsPath);
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new FileReader(hosts));
			String line;
			boolean isAnalyzeLine = false;
			while ((line = reader.readLine()) != null) {
				dataLines.add(line);
				//debug(line);
				if (LineAnalyzer.isBigenLine(line)) {
					if (!isAnalyzeLine) {
						menuLines.add(LineAnalyzer.getTargetKeyWord(line));
						isAnalyzeLine = true;
					}else{
						throw new HostsSwitcherException("Groups Definitions Error");
					}
				}
				else if ((isAnalyzeLine) && (LineAnalyzer.isEndLine(line))) {
					//System.out.println(line);
					isAnalyzeLine = false;
				}
			}
			if (isAnalyzeLine) {
				throw new Exception("Groups Definitions Error");
			}
		} catch (FileNotFoundException e) {
			throw e;
		} catch (IOException e) {
			throw e;
		} catch (Exception e) {
			throw e;
		} finally {
			try {
				if (reader != null) { reader.close(); }
			} catch (IOException e) {
				throw e;
			}
		}
		/*
		Iterator it = menuLines.iterator();
		while (it.hasNext()) {
			debug((String)it.next());
		}*/
	}
	
	public List getMenuLines(){
		return menuLines;
	}
	
	public void writeNewHosts() throws IOException {
		File hosts = new File(hostsPath);
		BufferedWriter bufferedWriter = null;
		try {
			bufferedWriter = new BufferedWriter(new FileWriter(hosts));
			Iterator it = dataLines.iterator();
			while (it.hasNext()) {
				bufferedWriter.write((String)it.next());
				bufferedWriter.newLine();
			}
		} catch (IOException e) {
			throw e;
		} finally {
			try {
				if (bufferedWriter != null ){ bufferedWriter.close(); }
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public void edit(String key) {
		//debug(key);
		boolean isActivateLine = false;
		boolean isAnalyzeLine = false;
		String editLine;
		for (int i = 0; i < dataLines.size(); i++){
			editLine = (String)dataLines.get(i);
			
			// hosts̃O[vsڂ̏
			if (LineAnalyzer.isBigenLine(editLine)) {
				//debug("if-1" + editLine);
				isAnalyzeLine = true;
				if (LineAnalyzer.getTargetKeyWord(editLine).equals(key)){
				// LɂO[v
					isActivateLine = true;
				}
				System.out.println(editLine);
			}
			else if ((isActivateLine) && (LineAnalyzer.isCommentOutData(editLine))){
			// LΏۃzXgO[vŃRgAEgĂsɑ΂鏈
				dataLines.set(i, LineAnalyzer.activateLine(editLine));
				System.out.println(LineAnalyzer.activateLine(editLine));
			}
			else if ((isAnalyzeLine) && !(isActivateLine) && (LineAnalyzer.isActiveData(editLine))){
			// LΏۊOsŁARgAEgĂȂsɑ΂鏈
				dataLines.set(i, LineAnalyzer.inactivateLine(editLine));
				System.out.println(LineAnalyzer.inactivateLine(editLine));
			}
			else if ((isAnalyzeLine) && (LineAnalyzer.isEndLine(editLine))) {
			// O[v̏I[`s
				System.out.println(editLine);
				isAnalyzeLine = false;
				isActivateLine = false;
			}
			else {
				System.out.println(editLine);
			}
		}
		//return ((isActivateLine == false) && (isAnalyzeLine == false));
	}
	
	private void debug(String s){
		System.out.println(this.getClass()	 + " DEBUG MSG : " + s);
	}
}
