package info.createwanwan.hostsswitcher.common;

import java.util.regex.Matcher;

public class LineAnalyzer {
	public static boolean isBigenLine(String line){
		return PatternsDefinition.BIGEN_PATT.matcher(line).matches();
	}
	public static boolean isEndLine(String line){
		return PatternsDefinition.END_PATT.matcher(line).matches();
	}
	public static boolean isCommentOutData(String line){
		return PatternsDefinition.COMMENTOUTDATA_PATT.matcher(line).matches();
	}
	public static boolean isActiveData(String line) {
		return PatternsDefinition.DATALINE_PATT.matcher(line).matches();
	}
	
	public static String inactivateLine(String line){
		return new StringBuffer().append('#').append(line).toString();
	}
	public static String activateLine(String line) {
		Matcher m = PatternsDefinition.COMMENTOUTDATA_PATT.matcher(line);
		if (m.find()){
			return m.group(2);
		} else {
			return "";
		}
	}
	
	public static String getTargetKeyWord(String line) {
		Matcher m = PatternsDefinition.BIGEN_PATT.matcher(line);
		if (m.find()){
			return m.group(1);
		} else {
			return "";
		}
	}
}
