/* HostsSwitcherV2 --------------------------------------------------
 * PropertiesHandler.java
 * -------------------------------------
 * CF
 *     2005/10/02	VK쐬
 * -----------------------------------------------------------------*/
package info.createwanwan.hostsswitcher.common;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

public class PropertiesHandler {
	private String propertiesPath;
	private static final String KEY_HOSTS_PATH = "hosts.path";
	private Properties configProperties = new Properties();
	
	public PropertiesHandler(){
		this.propertiesPath 
			=  new StringBuffer().append(System.getProperty("user.home"))
			.append(System.getProperty("file.separator"))
			.append("hostsswitcher.properties").toString();
	}
	
	public PropertiesHandler(String _propPath) throws IOException{
		this.propertiesPath = _propPath;
		configProperties.load(new FileInputStream(new File(propertiesPath)));
	}

	public String getHostsPath() {
		return (String)configProperties.get(KEY_HOSTS_PATH);
	}

	public void setHostsPath(String hostsPath) {
		configProperties.setProperty(KEY_HOSTS_PATH, hostsPath);
	}
	
	public void resetHostsPath() throws IOException{
		configProperties.setProperty(KEY_HOSTS_PATH, "");
		this.saveNewProperties();
	}
	
	public String getOptionPropertyValue(String key){
		return configProperties.getProperty(key);
	}
	
	public void setOptionPropertyValue(String key, String val) {
		configProperties.setProperty(key, val);
	}
	
	public void saveNewProperties() throws IOException {
		configProperties
			.store(new FileOutputStream(new File(propertiesPath)), "Hosts Swithcer Configuration Properties");
	}
	
}
